

// APT-generated file.

package org.carrot2.source.microsoft;

//Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

import java.util.*;
import javax.annotation.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.microsoft.Bing3DocumentSource} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.microsoft.Bing3DocumentSource")
public final class Bing3DocumentSourceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.microsoft.Bing3DocumentSource";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "Bing3DocumentSource";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "A base <code>IDocumentSource</code> sending requests to Bing Search API in Windows Azure Marketplace";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "We model this into separate subclasses, specific to a particular request type (web, image, news). <p>Important: there are limits for free use of the above API (beyond which it is a paid service).";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.appid);
        ownAttrs.add(attributes.market);
        ownAttrs.add(attributes.adult);
        ownAttrs.add(attributes.latitude);
        ownAttrs.add(attributes.longitude);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.microsoft.Bing3DocumentSourceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.microsoft.Bing3DocumentSourceDescriptor.attributes.market);
        allAttrs.add(org.carrot2.source.microsoft.Bing3DocumentSourceDescriptor.attributes.adult);
        allAttrs.add(org.carrot2.source.microsoft.Bing3DocumentSourceDescriptor.attributes.latitude);
        allAttrs.add(org.carrot2.source.microsoft.Bing3DocumentSourceDescriptor.attributes.longitude);
        allAttrs.add(org.carrot2.source.MultipageSearchEngineDescriptor.attributes.searchMode);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.start);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.results);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.query);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.resultsTotal);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.documents);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.compressed);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.microsoft.Bing3DocumentSource} component.
     */
    public static class Keys  extends org.carrot2.source.MultipageSearchEngineDescriptor.Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing3DocumentSource#appid}. */
        public static final String APPID = "Bing3DocumentSource.appid";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing3DocumentSource#market}. */
        public static final String MARKET = "Bing3DocumentSource.market";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing3DocumentSource#adult}. */
        public static final String ADULT = "Bing3DocumentSource.adult";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing3DocumentSource#latitude}. */
        public static final String LATITUDE = "Bing3DocumentSource.latitude";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing3DocumentSource#longitude}. */
        public static final String LONGITUDE = "Bing3DocumentSource.longitude";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.microsoft.Bing3DocumentSource} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo appid = 
            new AttributeInfo(
                "Bing3DocumentSource.appid",
                "org.carrot2.source.microsoft.Bing3DocumentSource",
                "appid",
                "Microsoft-assigned application ID for querying the API. Please <strong>generate\nyour own ID</strong> for production deployments and branches off the Carrot2.org's\ncode. See <a href=\"https://datamarket.azure.com/dataset/5ba839f1-12ce-4cce-bf57-a49d98d29a44\">http://goo.gl/usVXW</a>\nfor more.\n\n<p>By default takes the system property's value under key: <code>bing3.key</code>.</p>",
                "Application API key",
                "Microsoft-assigned application ID for querying the API",
                "Please <strong>generate your own ID</strong> for production deployments and branches off the Carrot2.org's code. See <a href=\"https://datamarket.azure.com/dataset/5ba839f1-12ce-4cce-bf57-a49d98d29a44\">http://goo.gl/usVXW</a> for more. <p>By default takes the system property's value under key: <code>bing3.key</code>.</p>",
                "Service",
                org.carrot2.util.attribute.AttributeLevel.BASIC,
                null
            );

        /**
         *          */
        public final AttributeInfo market = 
            new AttributeInfo(
                "Bing3DocumentSource.market",
                "org.carrot2.source.microsoft.Bing3DocumentSource",
                "market",
                "Language and country/region information for the request.",
                "Market",
                "Language and country/region information for the request",
                null,
                "Filtering",
                org.carrot2.util.attribute.AttributeLevel.BASIC,
                null
            );

        /**
         *          */
        public final AttributeInfo adult = 
            new AttributeInfo(
                "Bing3DocumentSource.adult",
                "org.carrot2.source.microsoft.Bing3DocumentSource",
                "adult",
                "Adult search restriction (porn filter).",
                "Safe search",
                "Adult search restriction (porn filter)",
                null,
                "Filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo latitude = 
            new AttributeInfo(
                "Bing3DocumentSource.latitude",
                "org.carrot2.source.microsoft.Bing3DocumentSource",
                "latitude",
                "Latitude (north/south coordinate). Valid input values range from \u201390 to 90.",
                "Latitude hint",
                "Latitude (north/south coordinate)",
                "Valid input values range from \u201390 to 90.",
                "Filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo longitude = 
            new AttributeInfo(
                "Bing3DocumentSource.longitude",
                "org.carrot2.source.microsoft.Bing3DocumentSource",
                "longitude",
                "Longitude (east/west coordinate). Valid input values range from \u2013180 to 180.",
                "Longitude hint",
                "Longitude (east/west coordinate)",
                "Valid input values range from \u2013180 to 180.",
                "Filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.microsoft.Bing3DocumentSource} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder  extends org.carrot2.source.MultipageSearchEngineDescriptor.AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
             super(map); 
            this.map = map;
        }


        
        
        /**
         * Microsoft-assigned application ID for querying the API. Please <strong>generate
your own ID</strong> for production deployments and branches off the Carrot2.org's
code. See <a href="https://datamarket.azure.com/dataset/5ba839f1-12ce-4cce-bf57-a49d98d29a44">http://goo.gl/usVXW</a>
for more.

<p>By default takes the system property's value under key: <code>bing3.key</code>.</p>
         * 
         * @see org.carrot2.source.microsoft.Bing3DocumentSource#appid 
         */
        public AttributeBuilder appid(java.lang.String value)
        {
            map.put("Bing3DocumentSource.appid", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Language and country/region information for the request.
         * 
         * @see org.carrot2.source.microsoft.Bing3DocumentSource#market 
         */
        public AttributeBuilder market(org.carrot2.source.microsoft.MarketOption value)
        {
            map.put("Bing3DocumentSource.market", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Adult search restriction (porn filter).
         * 
         * @see org.carrot2.source.microsoft.Bing3DocumentSource#adult 
         */
        public AttributeBuilder adult(org.carrot2.source.microsoft.AdultOption value)
        {
            map.put("Bing3DocumentSource.adult", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Latitude (north/south coordinate). Valid input values range from –90 to 90.
         * 
         * @see org.carrot2.source.microsoft.Bing3DocumentSource#latitude 
         */
        public AttributeBuilder latitude(java.lang.Double value)
        {
            map.put("Bing3DocumentSource.latitude", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Longitude (east/west coordinate). Valid input values range from –180 to 180.
         * 
         * @see org.carrot2.source.microsoft.Bing3DocumentSource#longitude 
         */
        public AttributeBuilder longitude(java.lang.Double value)
        {
            map.put("Bing3DocumentSource.longitude", value);
            return this;
        }
        
        
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
